#include <math.h>
#include "member_zero.h"

MemberZero::MemberZero (DCDT_Agora* dis, struct parameters *param, int myID, long int* cur_loop_ptr)
  :DCDT_Member(dis,param->period )
{
  ID = myID;

  current_loop = cur_loop_ptr;

 //DCDT_Member(dis,param->period);
  id_thread=param->id_thread;
  period=param->period;
  standard=param->standard;
  mathFuncs=param->mathFuncs;
  memory=param->memory;
  mem_size=param->mem_size;
  num_loops=param->num_loops;
  count_loops=0;
  lost_deadlines=0;
  exec_data=(struct results_t *)malloc(sizeof(struct results_t)*num_loops);
  //printf("th: %d %ld %d %d %d %ld %ld\n",id_thread,period,standard,mathFuncs,memory,mem_size,num_loops);

};

MemberZero::~MemberZero()
{
   free(exec_data);
};

void MemberZero::Init()
{
  //printf("MemberZero: Initializing\n");
  fflush(stdout);
 
  if( ID == 0 ) {
    //    printf("its my turn\n");
    *current_loop = count_loops;
  }

  // SetActivationCondition(GetAllMsgTypeMask());
};

void MemberZero::DoYourJob (int par)
{
     int num1, num2;
     char *str1,*str2;
     DCDT_TIME jitter;


  jitter=CycleTime-period;
  //  printf("jitter=%ld, ExecTime=%d\n", jitter, ExecTime);
  exec_data[count_loops].jitter=jitter;
  exec_data[count_loops].execTime=ExecTime;
  if (ExecTime>period) lost_deadlines++;

  //if this is Member 0 => set the global loop counter

  if( ID == 0 ) {
    //    printf("its my turn\n");
    *current_loop = count_loops;
  }


  count_loops++;


  if (count_loops >= num_loops)
  {
    //    printf("Status = TERMINATING");
    Status = TERMINATING;
    //count_loops = -2;
    //   DCDT_Msg* newMsg = CreateMsg(STOP_MSG);
    //    ShareMsg( newMsg );

    //    Shutdown(0);
  }

  //  Wait(800);


  for (int i=0;i<standard;i++)
    {
      num1=1;
      num2=num1+7;
               while( num2>num1)
		 {
                   num1++;
		 }
	       // fprintf(stderr,"num1=%d\n",num1);
    }
  //--2 operazioni aritmetiche
  for (int i=0;i<mathFuncs;i++)
    {
               switch(i%3)
		 {
		 case 0: sin((i+2)*9);
		 case 1: tan(i*4/2);
		 case 2: log(i*4);
		 }
    }
  //--3 operazioni memory
  for (int i=0;i<memory;i++)
    {
	   str1=(char*)malloc(sizeof(char)*mem_size);
	   str2=(char*)malloc(sizeof(char)*mem_size);
           memcpy(str2,str1,sizeof(char)*mem_size);
           free(str1);
	   free(str2);
    }
  
};


void MemberZero::Close()
{
  //printf("End of Thread num %d\n",id_thread);
  /*printf("\nMember0 Ho ricevuto %d msg di tipo 1\n",message_received_one);
  printf("Member0 Ho ricevuto %d msg di tipo 2\n",message_received_two);
  printf("Member0 Ho ricevuto %d msg di tipo 3\n",message_received_three);
  printf("Member0 Abbiamo %d errori sui messaggi\n",err);*/
};

struct results_t* MemberZero::GetData()
{
   return exec_data;
}

long int MemberZero::getCountLoop()
{
  if (Status==TERMINATING) return -1;
  return count_loops;
}

long int MemberZero::getPeriod()
{
 return period;
}
long int MemberZero::getNumLoops()
{
 return num_loops;
}
long int MemberZero::getLostDeadLines()
{
 return lost_deadlines;
}

