using namespace std;

#include "member_one.h"

MemberOne::MemberOne (DCDT_Agora* agora, unsigned long p )
:DCDT_Member(agora, p)
{
  period=p;
};

MemberOne::~MemberOne()
{
};

void
MemberOne::Init()
{
  printf("MemberOne: Initializing\n");
  fflush(stdout);

  SubscribeMsgType(2);
  SubscribeMsgType(3);
  SubscribeMsgType(4);

  LAT_INIT ( 1, 100 );
  LAT_DEADLINE( 0, ((double)period)/1000000 );
};

void
MemberOne::DoYourJob (int par)
{
  char *text;
  static int counter=0;

  LAT_SAMPLE(0,Exit());
  // Sia il messaggio che il contenuto ( payload ) non devono
  // essere deallocati perche' e' l'Agora stessa che li gestira'
  DCDT_Msg *txMsg = CreateMsg(1);
  txMsg->SetDeliveryWarranty(TCP_WARRANTY);
  text = (char *) malloc ( 30 );

  sprintf ( text, "Messaggio 1 (%d)", counter++ );
  txMsg->SetPayload(text, strlen(text)+1);
  //cout << "M1: Sharing msg type 1 - " << text << "\n";
  ShareMsg( txMsg );

 
  if ( ReceiveMsgType(2, NOBLOCKING ) != NULL ) {
     printf ( "Ricevuto Shutdown\n" );
     Exit();
  }
};

void
MemberOne::Close()
{
};
