/**********************************************
 * DCDT                       September 2002  *  
 *                                            *
 * Pinger.cpp                                 *
 *                                            *
 * originally developed by M.Matteucci        *
 * matteucc@airlab.elet.polimi.it             *
 **********************************************/


#include "Pinger.h"

Pinger::Pinger (DCDT_Agora* dis)
  :DCDT_Member(dis,100000)
{
}

Pinger::~Pinger()
{
}

void
Pinger::Init()
{
  SubscribeMsgType(MSG_FROM_QINTERFA);
}

void
Pinger::DoYourJob (int par)
{

  DCDT_Msg *rxMsg;

  while ( (rxMsg = ReceiveMsg()))
    {
      //     const DCDT_Msg *rxMsg = GetNextMsg();
      if (rxMsg->ReadType() == MSG_FROM_QINTERFA)
	{
	  printf("Pinger: Rispondo\n"); fflush(stdout);

	  DCDT_Msg *Msg = CreateMsg(MSG_FROM_PINGER);
	  ShareMsg(Msg);
	  RemoveCurrMsg();
	}
    }    
}

void
Pinger::Close()
{
  printf("\n Closing Pinger");fflush(stdout);
}


