/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
**!!!                                                                   
**!!!                   INFO SOLUTION SPA                     
**!!!                                                                   
**!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 
**!!!                                                                    
**!!! PROJECT       : ROBY                                 
**!!!                                                                    
**!!! CLASS         : ModuleDispatch                    
**!!!
**!!! PACKAGE       : Ethnos
**!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 
**!!!                                                                   
**!!! FILE NAME     : ModuleDispatch.h
**!!!                                                                   
**!!! CREATION DATE : 25.10.2001         
**!!!                                                                   
**!!! AUTHOR        : P.M.  Roby  Team                             
**!!!                                                                   
**!!!                                                                   
**!!!___________________________________________________________________
**!!!                                                                   
**!!! SPECS ON DOCS : <Spec. Doc Name A>  Rev.: AA.aa                   
**!!!                                                                     
**!!!                 <Spec. Doc Name B>  Rev.: BB.bb                   
**!!!                ............                                       
**!!!                                                                   
**!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
**!!!                                                                   
**!!! OVERVIEW      : ModuleExpert makes MIDDLEWARE transparent to 
**!!!	              expert modules (Task execution and message passing)
**!!!                 MIDDLEWARE is Ethnos.
**!!!                                                                   
**!!!                                                                   
**!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 
*/

#ifndef __MODULE_DISPATCH_H
#define __MODULE_DISPATCH_H
/*----------------------------------------------------------------------
 *--------------------- SYSTEM  INCLUDE FILES --------------------------
 *---------------------------------------------------------------------*/
//#include "../include/etexpert.h"
//#include "../include/etmsg.h"
//#include "../include/etkernel.h"
#include <DCDT_Agora.h>
#include <string>
using namespace std;
/*----------------------------------------------------------------------
 *--------------------- PROJECT INCLUDE FILES --------------------------
 *---------------------------------------------------------------------*/
#include "const.h"
/*----------------------------------------------------------------------
 *-----------------------  DEFINE MACRO  -------------------------------
 *---------------------------------------------------------------------*/

/*----------------------------------------------------------------------
 *-----------------------  DEFINE TYPES  -------------------------------
 *---------------------------------------------------------------------*/
typedef enum {NONE,WRITTEN,RED} MemFlag;
typedef struct MemArea{
  int CreatorId;
  int Name;
  int Length;
  MemFlag Flag;
} MemArea;
/*----------------------------------------------------------------------
 *-----------------------  DEFINE CLASS  -------------------------------
 *---------------------------------------------------------------------*/

class ModuleDispatch: public DCDT_Agora
{

  /*------------------- DEFINE CONSTRUCTOR/DESTRUCTOR -------------------*/
 public:
  /** default Constructor **/
  ModuleDispatch(char* config_file, string host_name = "");
 
  /** copy Constructor **/ 
   
  /** Destructor **/ 
  ~ModuleDispatch(void);
  
  /*---------------------------- PUBLIC ---------------------------*/
 public:
  /** Attribute: **/
  /** Methods: **/  
  // Get Expert ID
  int MD_GetExpertId();
  // Set Memory Area Length
  int MD_MemSetFlag(int Name,MemFlag NewFlag);
  // Get Memory Area Length
  MemFlag  MD_MemGetFlag(int Name);
  // Set Memory Area Length
  int MD_MemSetLength(int Name,int ExpertId,int Length);
  // Get Memory Area Length
  int MD_MemGetLength(int Name);
  // Get the name of the host
  string GetHostName();
  // Get the Robot Id
  int GetRobotId();
  
  /*--------------------------- PROTECTED -------------------------*/
 protected:
  /** Attribute: **/
  /** Methods: **/ 

  /*--------------------------- PRIVATE ---------------------------*/
 private:
  /** Attribute: **/
  // Counter of Expert in Dispatch System
  int ExpertIdCounter;
  // Counter of Memory Area in Dispatch System
  int MemoryCounter;
  
  // Variable to store Memory Area Informations
  MemArea Memory[MAX_MEMORY_AREA];
  
  string mHostName;
  /** Methods: **/
};

/*------------------- INLINE IMPLEMENTATION ------------------------*/

inline string ModuleDispatch::GetHostName()
{
  return mHostName;
}

inline int ModuleDispatch::GetRobotId()
{
  if (mHostName == "recam")
    return 26;
  else if (mHostName == "ridan")
    return 23;
  else if (mHostName == "rabbiati")
    return 25;
  else if (mHostName == "ribaldo")
    return 21;
  else if (mHostName == "robaldo")
    return 22;

  return -1;
}

#endif
/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! */
/*-------------------------- End Of Header File --------------------*/
/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! */
