/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
**!!!                                                                   
**!!!                   INFO SOLUTION SPA                     
**!!!                                                                   
**!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 
**!!!                                                                    
**!!! PROJECT       : ROBY                                 
**!!!                                                                    
**!!! CLASS         : ModuleMember
**!!!
**!!! PACKAGE       : Middleware
**!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 
**!!!                                                                   
**!!! FILE NAME     : ModuleExpert.cpp
**!!!                                                                   
**!!! CREATION DATE : 25.10.2001         
**!!!                                                                   
**!!! AUTHOR        : P.M.  Roby  Team                             
**!!!                 Cristian Giussani
**!!!                                                                   
**!!!                                                                   
**!!!___________________________________________________________________
**!!!                                                                   
**!!! SPECS ON DOCS : <Spec. Doc Name A>  Rev.: AA.aa                   
**!!!                                                                     
**!!!                 <Spec. Doc Name B>  Rev.: BB.bb                   
**!!!                ............                                       
**!!!                                                                   
**!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
*/

#include <string.h>
#include <iostream>
#include "StringModuleMember.h"
#include "const.h"

StringModuleMember::StringModuleMember (ModuleDispatch *Dispatch,
			    unsigned int period, string name ):  
  ModuleMember( Dispatch, (DCDT_TIME)period, name )
{
  mIsMessageOpened=false;
}

   
StringModuleMember::~StringModuleMember ()
{
}

void StringModuleMember::NewMessage( int msg_type, string type )
{
  CloseCurrentMessage();
  
  struct timeval timestamp;
  gettimeofday(&timestamp,0);

  // Write the message header
  mCurrentMessage << "<MESSAGE id = " << type
                  << " sender = " << Dispatcher->GetHostName()
                  << " timestamp = " << "_" << timestamp.tv_sec << "_" << timestamp.tv_usec
                  << " module = " << mModuleName << ">\n";

  mMessageId = msg_type;
  mIsMessageOpened = true;
}

void StringModuleMember::CloseCurrentMessage(  )
{
  if ( mIsMessageOpened ) {
    mCurrentMessage << "</MESSAGE>\n" << '\0';
    mMessages[mMessageId].push_back(mCurrentMessage.str());

    // Empty the message string
    mCurrentMessage.str(string());
    mIsMessageOpened = false;
  }
}

void StringModuleMember::SendStringMessage( int message )
{
  unsigned char *msg;
  unsigned int length;
  // If we were writing another message, we close it and put it in the message queue
  CloseCurrentMessage();

  // Sending of all the messages of type "message" that are queued
  for (unsigned int i = 0; i < mMessages[message].size(); i++) {
    length = mMessages[message][i].size()*sizeof(char);
    msg = (unsigned char *)malloc( length+1 );
    memcpy ( msg, mMessages[message][i].c_str(), length );

    SendMessage(msg, (unsigned short) length, message);
  }
  
  // Erasing from the queue all the messages of type "message"
  mMessages[message].clear();
}

void StringModuleMember::SendAllStringMessages()
{
  map<int, vector<string> >::iterator it;
  for (it = mMessages.begin(); it != mMessages.end(); it++)
    {
      SendStringMessage(it->first);
    }
}

void StringModuleMember::CloseMessage()
{
	mCurrentMessage << "</MESSAGE>\n" << '\0';
}


int StringModuleMember::strtovalue(char* buf, char* del,float* ris)
{
	int i,j;
	int sub1=0; 
	int t1,t2;
	char* buf2;
	float f;
	int found = 0; 
	for(i=0;buf[i]!=NULL;i++){
		sub1=0;
		for(j=0;del[j]!=NULL && sub1 ==0;j++){
			if(del[j]!=buf[i+1+j]){
				sub1=1;
			}
		}
		if (sub1==0){
			t1=i+j+1;
			i=t1;
			while(buf[i]!='<'&& buf[i] != ' '){
				i++;
			}
			t2=i-1;
			found=1;
		}
	}
	if (found == 1){
		buf2=(char*)malloc(sizeof(char)*(t2-t1+2));
		for(i=0;i<(t2-t1+1);i++){
			buf2[i]=buf[t1+i];
		}
		buf2[i]=NULL;
//		printf("*%s*\n",buf2);
		if(ris!=NULL){
			sscanf(buf2,"%f",ris);
		}
		free(buf2);
		return 1;
	}else{
		return 0;
	}
}


weightfloat StringModuleMember::getFilteredData(weightfloat new_data,weightfloat vect[],int num_data,float att,int* null_data)
{
	int i,nvalid=0;
	float totv=0,totw=0;
	weightfloat result;
	
	for(i=num_data-1;i>0;i--){
		vect[i]=vect[i-1];
		vect[i].w=vect[i].w/att;
	}
	vect[0]=new_data;
	
	/*for(i=0;i<num_data;i++){
		printf("%d -> %f     %f\n",i,vect[i].v,vect[i].w);
	}*/
	for(i=0;i<num_data;i++){
		if (vect[i].w==0){
			nvalid++;
		}
		totv +=(vect[i].v * vect[i].w);
		totw += vect[i].w;
	}
	if(totw!=0){
		result.v= (totv/totw);
	}
	result.w= (totw/num_data);
	if (null_data!=NULL){
		*null_data=nvalid;
	}
	return result;
}	

pdistance StringModuleMember::ppdistance(pos p1, pos p2)
{
	pdistance t;
	float ta;
	t.d = sqrt(pow((p1.x-p2.x),2)+pow((p1.y-p2.y),2));
	
	ta= radtodeg(atan2(p1.y-p2.y,p1.x-p2.x));
	
	t.a=a360to180(norangle(180+ta-p1.a));
	
	return t;	
}

float StringModuleMember::norangle(float a)
{
	float t;
	t=a;
	
	while(fabs(t)>=360){
		if(t>=360) t-=360;
		if(t<0) t+=360;
	}
	if(t<0){
		t=(360+t);
	}
	
	return t;
}

float StringModuleMember::a360to180(float a)
{
	float t;
	t=norangle(a);
	if (t>180){
		t=-(360-t);
	}
	return t;
}

float StringModuleMember::a180to360(float a)
{
	float t;
	t=norangle(a);
	if (t<0){
		t=(360+t);
	}
	return t;
}

float StringModuleMember::degtorad(float deg)
{
	return ((PI*deg)/180);
}
float StringModuleMember::radtodeg(float rad)
{
	return ((180*rad)/PI);
}
