#include <WheelChairUtil.h>
#include <stdio.h>
#include <math.h>

using namespace std;


void semplificaProfiloRec(float *x,float *y,int start, int end,float deltaStop,vector<int> &id);

bool stringToFloat(float& t, string s){
	std::istringstream iss(s);
	
	return !(iss >> std::dec >> t).fail();
}

void semplificaProfiloRec(float *x,float *y,int start, int end,float deltaStop,vector<int> &id){
	int imax=-1;
	float dmax=0;
	float delta,den;
	float xno,yno,ts,t1,t2;
	xno=x[end]-x[start];
	yno=y[end]-y[start];
	den=xno*xno+yno*yno;
	if(start<end){
		for(int i=start+1;i<end;i++){
			ts=( xno*(y[i]-y[start]) - yno*(x[i]-x[start]) )/den;
			t1=yno*ts;
			t2=-xno*ts;
			delta=sqrt(t1*t1+t2*t2);
			if(delta>dmax){
				imax=i;
				dmax=delta;
			}
		}
		//in imax c'è l'indice del punto più lontano dalla retta (distanza dmax)
		if(imax!=-1){
			//quasi impossibile, dovrebbero essere tutti allineati...
			if(dmax>=deltaStop){
				semplificaProfiloRec(x,y,start,imax,deltaStop,id);
				id.push_back(imax);
				semplificaProfiloRec(x,y,imax,end,deltaStop,id);
			}
			
		}
	}
}

vector<int> semplificaProfilo(float *x,float *y,int n,float errMax){
	vector<int> id;
	id.push_back(0);
	semplificaProfiloRec(x,y,0,n-1,errMax,id);
	id.push_back(n-1);
return id;
}

float rad2deg(float d){
	return d*180/M_PI;
}


float deg2rad(float d){
	return d*M_PI/180;
}


void printAndDelete(char *s){
	printf("%s",s);
	delete [] s;
}

