/*
 * AIRboardUI: graphical interface program to interact with airboard
 * through RS232 serial port.
 *
 * In order to compile this package you have to install the
 * Java Communications API on your system.
 * http://java.sun.com/products/javacomm/downloads/index.html
 * 
 * Bruschieri Stefano
 * Campari PierPaolo
 */

package airboardUI;
import java.awt.*;
import javax.swing.JOptionPane;

/**
* A single response modal alert dialog. This class is configurable for message 
* and title. This class define a set of possible warnings or errors showed by the
* program. When the OK button is pressed the dialog returns.
*/
public class AlertDialog {

    /**
    * Creates a new <code>AlertDialog</code> with some diagnostic information.
    * 
    * @param parent Any Frame.
    * @param title The title to appear in the border of the dialog.
    * @param message Message in the dialog.
    */
    public AlertDialog(Frame parent, 
		       String title,
		       String message) {

    	JOptionPane.showMessageDialog(parent, message, title, JOptionPane.WARNING_MESSAGE);
	
    }

}
