#include "PositionExpert.h"
#include "MotorConstants.h"
#include <iostream>

extern int needodo;

PositionExpert::PositionExpert(ModuleDispatch* kernel,int period) : 
  StringModuleMember(kernel,period,"position")
{
  printf("\nPositionExpert built");
  fflush(stdout);
};

PositionExpert::~PositionExpert()
{
  printf("\nPositionExpert destroyed");
  fflush(stdout);
};

void PositionExpert::RunInit()
{
 	AddMessageRequest( MSG_FROM_MOTION,LOCAL );
 	AddMessageRequest( MSG_POSITION_P,LOCAL );
  
	lastsec=0;
	lastusec=0;
	lasttanspeed=0;
	lastrotspeed=0;
	
	rob.x=STARTX;
	rob.y=STARTY;
	rob.a=STARTANGLE;
	
	settimer(1);

  	printf("\nPositionExpert initialized");
  	fflush(stdout);
};

/* ***********************************
   
   DoYourDuty()

   *********************************** */

void PositionExpert::RunDuty()
{
  	unsigned char* buffer;
  	unsigned char* buffer2;
	char* buf;
	float f;
	int i;
	float e;
	float tanspeed,rotspeed;
	int odovalid=0;

  	/*if(ReceiveLastMessage(MSG_POSITION_P, buffer, false) > 0)
	{
  		if(strtovalue((char*)buffer,"invalidposition ",&f))
		{
  			printf("\nInvalid led position");
  			if(ReceiveLastMessage(MSG_FROM_MOTION, buffer2, false) > 0)
			{
				printf("\nCalcolo con odometria");
				for(i=0;buffer2[i]!=NULL;i++){
					;
				}
				buf=(char*)malloc(i+1);
				strcpy(buf,(char*)buffer2);
				//printf("%s\n",buf);
				e=((float)elapsedtime(buf))/1000000;
				if(firstodo){
					e=0;
					firstodo = 0;
				}
				printf(", Tempo trascorso: %f",e);
				int c = 0;
				for (; ((buffer2[c] != NULL) && (buffer2[c] != '>')); c++);
				for (c++; ((buffer2[c] != NULL) && (buffer2[c] != '>')); c++);
				float tanSpeed = 0;
				for (int a = 1, d = 1; buffer2[c - a] != '<'; a++, d *= 10)
				{
					if (buffer2[c - a] == '-')
					{
						tanSpeed *= -1;
						continue;
					}
					tanSpeed += (buffer2[c - a] - '0') * d;
				}
				for (c++; ((buffer2[c] != NULL) && (buffer2[c] != '>')); c++);
				float rotSpeed = 0;
				for (int a = 1, d = 1; buffer2[c - a] != '<'; a++, d *= 10)
				{
					if (buffer2[c - a] == '-')
					{
						rotSpeed *= -1;
						continue;
					}
					rotSpeed += (buffer2[c - a] - '0') * d;
				}
				//printf("\nVelocità: %d, %d", tanSpeed, rotSpeed);
				//fflush(stdout);
				printf(", X: %f, Y: %f, A: %f", rob.x, rob.y, rob.a);
				//fflush(stdout);
				if (tanSpeed > 0)
				{
					//tanSpeed = 0.0029 * tanSpeed + 0.26;
					tanSpeed = 0.00277 * tanSpeed + 0.284;
				}
				if (tanSpeed < 0)
				{
					tanSpeed = -1 * (-0.00277 * tanSpeed + 0.284);
				}
				if (rotSpeed > 0)
				{
					rotSpeed = 0.0277 * rotSpeed + 1.4437;
				}
				if (rotSpeed < 0)
				{
					rotSpeed = -1*(-0.0277 * rotSpeed + 1.4437);
				}
				//rob.a+=rotSpeed*e;
				rob.a += rotSpeed * e * 57.296; //57.296 = 180/3.14
				rob.a=norangle(rob.a);
				rob.x+=tanSpeed*(cos(degtorad(rob.a)))*e*100;
				rob.y+=tanSpeed*(sin(degtorad(rob.a)))*e*100;
				printf(", TanSpeed: %f, RotSpeed %f", tanSpeed, rotSpeed);
				printf(", X2: %f, Y2: %f, A2: %f", rob.x, rob.y, rob.a);
				NewMessage(MSG_POSITION,POS_DATA);
				mCurrentMessage<<" posx "<<rob.x<<" posy "<<rob.y<<" angle "<<rob.a<<" \n";
				//cout<<mCurrentMessage.str();
				CloseMessage();
				SendAllStringMessages();
				
				//printf("odometria %d\n",firstodo);
				firstodo=0;
			}
		}
		else
		{
			needodo=0;
			settimer(1);
			if(strtovalue((char*)buffer,"posx ",&f)){
				rob.x=f;
			}
			if(strtovalue((char*)buffer,"posy ",&f)){
				rob.y=f;
			}
			if(strtovalue((char*)buffer,"angle ",&f)){
				rob.a=f;
			}
			NewMessage(MSG_POSITION,POS_DATA);
  			mCurrentMessage<<buffer;
  			SendAllStringMessages();
  			if(ReceiveLastMessage(MSG_FROM_MOTION, buffer2, false) > 0)
			{
				for(i=0;buffer2[i]!=NULL;i++){
					;
				}
				buf=(char*)malloc(i+1);
				strcpy(buf,(char*)buffer2);
				//printf("%s\n",buf);
				e=((float)elapsedtime(buf))/1000000;
			}
  			return;
		}
	}
	else
		return;
		/*if(elapsed(1)>NOTVISIONLIMIT){
 			NewMessage(MSG_POSITION,POS_DATA);
  			mCurrentMessage<<"invalidposition ";
  			SendAllStringMessages();
		}else
		{
			needodo=1;
		}*/

};

void PositionExpert::RunClose()
{
  printf("\nPositionExpert closed");
  fflush(stdout);
};

long PositionExpert::elapsedtime(char* buf)
{
	long sec,usec,e;
	int i;
	int t=0;
	char* buf10=(char*)malloc(50);
	char* buf11=(char*)malloc(50);
	char* buf12=(char*)malloc(50);

	sscanf(buf,"%*s%*s%*s%*s%*s%*s%*s%*s%*s%s",buf10);
	for(i=1;buf10[i]!=NULL;i++){
		if(buf10[i]=='_'){
			i++;
			t=i;
			//i+=2;
		}
		if (t==0){
			buf11[i-1]=buf10[i];
		}else{
			buf12[i-t]=buf10[i];
		}
	}
	buf11[t-2]=NULL;
	buf12[i-t]=NULL;
	
	sscanf(buf11,"%d",&sec);
	sscanf(buf12,"%d",&usec);
	
	free (buf10);
	free (buf11);
	free (buf12);
	
	if(lastsec==0){
		lastsec=sec;
		lastusec=usec;
		return 0;
	}else{
		e=(((sec-lastsec)*1000000)+(usec-lastusec));
		lastsec=sec;
		lastusec=usec;
		return e;
	}
}
	
long PositionExpert::elapsed(int i)
{ 
	struct timeval now;
	long elapsed_usec = 0;

	gettimeofday(&now, NULL);

	if (now.tv_usec > 1000000) {
		now.tv_usec -= 1000000;
		++now.tv_sec;
	}

	if (now.tv_sec > last_render[i].tv_sec){
		elapsed_usec = ((now.tv_sec - last_render[i].tv_sec) * 1000000);
	}

	if (now.tv_usec > last_render[i].tv_usec)
		elapsed_usec += now.tv_usec - last_render[i].tv_usec;
	else
		elapsed_usec -= last_render[i].tv_usec - now.tv_usec;


	return elapsed_usec ;

}

void PositionExpert::settimer(int i)
{
	gettimeofday(&(last_render[i]),NULL);
	return;
}

