#include <const.h>
#include <string>
#include <type.h>
#include <cmath>


#define BRIAN
#define WIIM
#define MOTOR
#define LOG
#define SONAR
#define SPYKEE
//#define SONARRECEPTION
//#define POSITION
//#define VISIONPOSITION

#ifdef VISIONPOSITION
	//#define SPYKEE
#endif
#ifdef MOTOR
	#define SPYKEE
#endif
#ifdef DUMMYPOSITION
	//#define POSITIONDUMMY
#endif
#ifdef CAMERAPOSITION
	#define POSITIONARWIIM
#endif
#ifdef ODOPOSITION
	#define POSITIONODO
#endif
#ifdef VISIONPOSITION
	#define VISION
	#include "GestioneConfigurazione.h"
	#include "MrtLogger.h"
#endif
#ifdef ODOVISIONPOSITION
	#define VISION
	#include "GestioneConfigurazione.h"
	#include "MrtLogger.h"
	#define POSITION
#endif



//non bisogna mandare troppi messaggi!
#ifdef BRIAN //brian e motor stanno in attesa di un messaggio, non serve temporizzarli?
#include "BrianExpert.h"
int brian_period=0; //in microsecondi
#endif

//#ifdef SPYKEE
#include "Spykee.h"
//#endif

#ifdef SONARRECEPTION
#include "SonarReceptionExpert.h"
int sonarReception_period = 100;
#endif

#ifdef SONAR
#include "SonarExpert.h"
int sonar_period=100;
#endif 

#ifdef WIIM
#include "WiimExpert.h"
int wiim_period=1000;
#endif

#ifdef MOTOR
#include "MotorExpert.h"
int motor_period=50000;
#endif

#ifdef LOG
#include "LogExpert.h"
int log_period=10000;
#endif

#ifdef POSITIONDUMMY
#include "PositionDummyExpert.h"
int position_dummy_period=0;
#endif

#ifdef POSITIONODO
#include "PositionOdoExpert.h"
int position_Odo_period=0;
#endif

#ifdef POSITIONARWIIM
#include "PositionExpertArwiim.h"
int position_Arwiim_period=33000;
#endif

#ifdef VISION
//#include "VisionExpert.h"
int Vision_period=100000;
#endif

#ifdef POSITION
#include "PositionExpert.h"
int position_period=1000;
#endif


// DCDT Configuration files
string dcdt_config_file("./config/dcdt.conf");
string default_hostname("hostname");

int main(int argc, char** argv)
{
  Spykee* s;
  // First thing parsing the input ...
  printf("\n argc=%d \n", argc);
  for (int i=0; i <=argc; i++)
  printf("\nargv[%d]=%s\n",i,  argv[i]);
  
#ifdef SPYKEE
	char user[] = {'a', 'd', 'm', 'i', 'n', '\0'};
	char pass[] = {'a', 'd', 'm', 'i', 'n', '\0'};
	s = new Spykee(user, pass);
	s->unplug();
	//s->startCamera();
#endif

  #ifdef VISION
	if(GestioneConfigurazione::init("config/config.ini",argc,argv)!=0)exit(0);
	if(MrtLogger::init()!=0){
		printf("error: no log will be produced!!\npress key to continue\n");
		getchar();
	}
  #endif

  // Create the Dispatcher
  ModuleDispatch* Dispatch = new ModuleDispatch ("", basename(argv[0]));
  
  // Create the Agent list
  std::vector < StringModuleMember * >agents;

  // ----------- SONARRECEPTION ----------- //
#ifdef SONARRECEPTION
	SonarReceptionExpert* pSonarReception = new SonarReceptionExpert (Dispatch, sonarReception_period); 
	agents.push_back(pSonarReception);
	cout << endl << "--- SonarReceptionExpert Created --- "<<endl; 
#endif

  // ----------- BRIAN ----------- //
#ifdef BRIAN
 	BrianExpert* pBrian = new BrianExpert (Dispatch,brian_period,false);  
 	agents.push_back(pBrian);
 	cout << endl << "--- BrianExpert Created --- "<<endl; 
#endif
  // ----------- MOTOR ----------- //
#ifdef MOTOR
 	MotorExpert* pMotor = new MotorExpert (Dispatch, motor_period, s); 
 	agents.push_back(pMotor);
	cout << endl << "--- MotorExpert Created --- "<<endl; 
#endif
  // ----------- MONITOR ----------- //
#ifdef MONITOR  
	MonitorExpert* pMonitor = new MonitorExpert (Dispatch, wiim_period);
	agents.push_back(pWiim);
	cout << endl << "--- MonitorExpert Created --- "<<endl; 
#endif

#ifdef LOG  
	LogExpert* pLog = new LogExpert (Dispatch, log_period);
	agents.push_back(pLog);
	cout << endl << "--- LogExpert Created --- "<<endl; 
#endif

#ifdef POSITIONDUMMY
 	PositionDummyExpert* pPosition = new PositionDummyExpert (Dispatch, position_dummy_period); 
 	agents.push_back(pPosition);
	cout << endl << "--- PositionDummyExpert Created --- "<<endl; 
#endif

#ifdef POSITIONODO
 	PositionOdoExpert* pOdoPosition = new PositionOdoExpert (Dispatch, position_Odo_period); 
 	agents.push_back(pOdoPosition);
	cout << endl << "--- PositionOdoExpert Created --- "<<endl; 
#endif

#ifdef POSITIONARWIIM
 	PositionExpertArwiim* pPositionArwiim = new PositionExpertArwiim (Dispatch, position_Arwiim_period,argc,argv); 
 	agents.push_back(pPositionArwiim);
	cout << endl << "--- PositionExpert Arwiim Created --- "<<endl; 
#endif

#ifdef VISION
	VisionExpert* pVision = new VisionExpert (Dispatch, Vision_period, s); 
	agents.push_back(pVision);
	cout << endl << "--- Vision Created --- "<<endl; 
#endif

#ifdef POSITION
	PositionExpert* pPosition = new PositionExpert (Dispatch, position_period); 
	agents.push_back(pPosition);
	cout << endl << "--- PositionExpert Created --- "<<endl; 
#endif

  // ----------- WIIM ----------- //
#ifdef WIIM  
	WiimExpert* pWiim = new WiimExpert (Dispatch, wiim_period, s);
	agents.push_back(pWiim);
	cout << endl << "--- WiimExpert Created --- "<<endl; 
#endif

  // ----------- SONAR ----------- //
#ifdef SONAR
 	SonarExpert* pSonar = new SonarExpert (Dispatch, sonar_period); 
 	agents.push_back(pSonar);
 	cout << endl << "--- SonarExpert Created --- "<<endl; 
#endif


  for (std::vector < StringModuleMember * >::iterator i = agents.begin (); i != agents.end (); i++)
    Dispatch->AddMember (*i);
  
  cout << endl << "--- Community Created --- "<<endl; 
  
  for (std::vector < StringModuleMember * >::iterator i = agents.begin (); i != agents.end (); i++)
    Dispatch->ActivateMember (*i);
  
  Dispatch->LetsWork ();
   cout << endl << "--- ''let's work, be proud...'' --- "<<endl;   
   
   
 /*  for(std::vector<StringModuleMember*>::iterator i = agenti.begin(); i!=agenti.end(); i++)
     delete *i;
  delete Dispatch;*/ //*wiim*

  cout << endl << "--- Community Session Terminated --- "<<endl;   
  return 0;


}
