#ifndef CONST_H
#define CONST_H

const unsigned int STRING_LENGTH = 32;
const int MAX_MEMORY_AREA = 10;
const int RC_OK = 0;
const int RC_ERROR = -1;

#define YELLOW 0
#define BLUE 1
#define NUM_SET_POINTS 3
#define HOME 1
#define GOAL 0

//*** definizione relative a robowii ******************************************************************
#define PI 3.14159265358979323846

#define STARTMODE 1 //0 manual, 1 auto

#define NORTH		2
#define NORTHEAST	8
#define EAST		4
#define SOUTHEAST	14
#define SOUTH		0
#define SOUTHWEST	12
#define WEST		6
#define NORTHWEST	10
#define MAXDISTANCE	7000
#define SENSORS_NUMBER	8

//varie posizioni (in coordinate di gioco)
#define STARTX 0
#define STARTY 100
#define STARTANGLE 0
#define GOALX 0
#define GOALY 300
#define HOMERADIUS 30 //raggio della home
#define GOALRADIUS 20 //raggio del goal

//parametri media mobile sul calcolo del centro
#define IRCENTERFILTER 20
#define IRCENTERATT 1.15

#define IRCENTERLIMIT 250 //raggio in cui il robot si considera puntato
#define IRCENTERHIT 50 //raggio zona in cui il robot può essere colpito

#define AIRBOARD_OUT "log/airboard.txt"   //file o periferica dove inviare i comandi diretti alla scheda di controllo
		  // mettere /dev/ttyUSB0 per porta seriale tramite usb

#define BRIAN_THRESHOLD 0.2 //limite minimo per considerare un comportamento attivo

//file di log
#define BRIANLOG "log/mt.dat" //registra i livelli di attivazione dei comportamenti e i dati in ingresso e uscita (importabile in matlab)
#define BRIANFULLLOG "log/brianfull.dat" //log completo di brian
#define BRIANMSGLOG "log/brianmsg.dat" //log dei messaggi ricevuti da brian
#define POSITIONLOG "log/position.dat" //log della posizione del robot (x,y e angolo)

//selezionare il sistema di localizzazione desiderato
//#define CAMERAPOSITION 1
//#define VISIONPOSITION 2
//#define ODOPOSITION 3
#define DUMMYPOSITION 4
//#define ODOVISIONPOSITION 5

//parametri di conversione fra coordinate dei sistemi di localizzazione e coordinate di gioco
#define ODOTANSCALE -1.5
#define ODOROTSCALE 4.7

#define VISIONSCALE 5

#define VISIONSCALEX -4
#define VISIONSCALEY -4
#define VISIONTRAX 350
#define VISIONTRAY 200

//parametri media mobile sulla posizione del robot
#define POSITIONFILTER 7
#define POSITIONATT 1.20

//tempo (microsecondi) durante il quale il robot utilizza l'odometria se non vede nessun marker (in modalità ODOVISIONPOSITION)
#define NOTVISIONLIMIT 10000000

//*********************************************************************

// Definizione costanti per i compiti
#define ALIGNTOBALL 1 
#define GOTOGOAL 2
#define GOTOXY 3
#define ALIGNPAR 4
#define DEFENCE 5
#define FREE 6

#define KICKIN TRUE
// Modificato per spedire anche il tempo di esecuzione
#define NUM_OBJ_AND_WALLS 35

// Modalita' di funzionamento del robot
#define MANUAL 0
#define AUTO 1
#define SHUTDOWN 2
#define SET_MODE 3
#define MANUAL_MOVE 4 
#define SET_GOAL 7

// numero di possibili comportamenti
#define NUM_BEHAVIORS 18
#define NUM_PREDICATES 30 

//numero di oggetti per colore
#define N_ROBOTS  35
#define N_PORTE    2
#define N_PALLE    3
#define N_MURI    16
#define OTHER_ROBOTS 7
#define OUR_ROBOTS 3
#define N_OBJECTS 2


#endif
