#ifndef MSG_H
#define MSG_H

#include <string>

/* definizione dei tipi di messaggio 
   che si possono scambiare i nostri robot */
   
const int MSG_FROM_WIIMOTE = 1;
const int MSG_FROM_VISION = 20;
const int MSG_FROM_MOTION = 21;
const int MSG_FROM_MONITOR = 22;
const int MSG_FROM_MAP = 23;
const int MSG_FROM_SCARE = 24;
const int MSG_FROM_BRIAN = 25;
const int MSG_FROM_BIG_BROTHER = 26;
const int MSG_FROM_ANCHORER = 27;
const int MSG_FROM_REFBOX = 28;

const int MSG_TO_BRIAN  = 31;
const int MSG_TO_MOTION = 32;
const int MSG_TO_BIG_BROTHER = 33;
const int MSG_TO_ANCHORER = 34;
const int MSG_TO_WIIM = 35;
const int MSG_TO_LOG = 36;
const int MSG_TO_SONAR = 37;

const int MSG_POSITION = 40;
const int MSG_POSITION_P = 41;

const std::string LED_DATA = "led_data";
const std::string DISTANCES_DATA = "distances_data";
const std::string WIIMOTE_DATA = "wiimote_data";
const std::string POS_DATA = "position_data";
const std::string COMMAND_DATA = "command_data";
const std::string BRIAN_DATA = "brian_data";
const std::string LOCAL_MAP_DATA = "local_map_data";
const std::string MAP_DATA = "map_data";
const std::string MONITOR_DATA = "monitor_data";
const std::string VISION_DATA = "vision_data";
const std::string VISION_DATA_OUTER = "vision_data_outer";
const std::string VISION_DATA_INNER = "vision_data_inner";
const std::string MOTION_DATA = "motion_data";
const std::string ANCHORING_DATA = "anchoring_data";
const std::string REFBOX_DATA = "refbox_data";

const std::string RED_BLOB_DATA = "RedBlob";
const std::string BLACK_BLOB_DATA = "BlackBlob";
const std::string YELLOW_BLOB_DATA = "YellowBlob";
const std::string BLUE_BLOB_DATA = "BlueBlob";
const std::string CYAN_BLOB_DATA = "CyanBlob";
const std::string MAGENTA_BLOB_DATA = "MagentaBlob";

const std::string BLOB_MIN_DISTANCE_DATA = "MinDistance";
const std::string BLOB_MAX_DISTANCE_DATA = "MaxDistance";
const std::string BLOB_MIN_ANGLE_DATA = "MinAngle";
const std::string BLOB_MAX_ANGLE_DATA = "MaxAngle";

const std::string BLUE_GOAL_PERCEPTION_DATA = "Blue";
const std::string YELLOW_GOAL_PERCEPTION_DATA = "Yellow";
const std::string YELLOW_BLUE_TRANSITION_DATA = "YB";
const std::string BLUE_YELLOW_TRANSITION_DATA = "BY";
const std::string BLUE_YELLOW_BLUE_TRANSITION_DATA = "BYB";
const std::string YELLOW_BLUE_YELLOW_TRANSITION_DATA = "YBY";

const std::string WHITE_PERCEPTION_DATA = "W";
const std::string GREEN_WHITE_TRANSITION_DATA = "GW";
const std::string WHITE_GREEN_TRANSITION_DATA = "WG";
const std::string GREEN_WHITE_GREEN_TRANSITION_DATA = "GWG";
const std::string CORNER_DATA = "Corner";
const std::string LINE_DATA = "Line";

//VisionExpert

const int MSG_FROM_VISION_POS			= 110;
const std::string VISION_POS			= "vision_position";
const std::string VISION_MARKER_ID		= "marker_id";
const std::string VISION_TIME_STAMP_SEC		= "time_stamp_sec";
const std::string VISION_TIME_STAMP_USEC	= "time_stamp_usec";
const std::string VISION_X			= "X";
const std::string VISION_Y			= "Y";
const std::string VISION_ANGLE			= "A";

const std::string D_OPEN_DATUM			= "<D>";
const std::string D_CLOSE_DATUM			= "</D>";


#endif
